/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.18 Revision 1.113
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.18 2009/01/21 08:55:28 gengor Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.113 2011/12/31 00:46:04 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Caleb Tennis <caleb@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
11 11
12inherit eutils multilib toolchain-funcs flag-o-matic 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
13 13
14IUSE="${IUSE} debug pch"
15
16case "${PV}" in
17 4.4.0_beta*)
18 SRCTYPE="${SRCTYPE:-opensource-src}"
19 MY_PV="${PV/_beta/-beta}"
20 ;;
21 4.4.0_rc*)
22 SRCTYPE="${SRCTYPE:-opensource-src}"
23 MY_PV="${PV/_rc/-rc}" 14MY_PV=${PV/_/-}
24 ;; 15MY_P=qt-everywhere-opensource-src-${MY_PV}
25 *) 16
26 SRCTYPE="${SRCTYPE:-opensource-src}" 17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
27 MY_PV="${PV}" 18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
28 ;; 19LICENSE="|| ( LGPL-2.1 GPL-3 )"
29esac 20
30MY_P=qt-x11-${SRCTYPE}-${MY_PV} 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
32RDEPEND="
33 !<x11-libs/qt-assistant-${PV}
34 !>x11-libs/qt-assistant-${PV}-r9999
35 !<x11-libs/qt-core-${PV}
36 !>x11-libs/qt-core-${PV}-r9999
37 !<x11-libs/qt-dbus-${PV}
38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
41 !<x11-libs/qt-demo-${PV}
42 !>x11-libs/qt-demo-${PV}-r9999
43 !<x11-libs/qt-gui-${PV}
44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
47 !<x11-libs/qt-opengl-${PV}
48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-phonon-${PV}
50 !>x11-libs/qt-phonon-${PV}-r9999
51 !<x11-libs/qt-qt3support-${PV}
52 !>x11-libs/qt-qt3support-${PV}-r9999
53 !<x11-libs/qt-script-${PV}
54 !>x11-libs/qt-script-${PV}-r9999
55 !<x11-libs/qt-sql-${PV}
56 !>x11-libs/qt-sql-${PV}-r9999
57 !<x11-libs/qt-svg-${PV}
58 !>x11-libs/qt-svg-${PV}-r9999
59 !<x11-libs/qt-test-${PV}
60 !>x11-libs/qt-test-${PV}-r9999
61 !<x11-libs/qt-webkit-${PV}
62 !>x11-libs/qt-webkit-${PV}-r9999
63 !<x11-libs/qt-xmlpatterns-${PV}
64 !>x11-libs/qt-xmlpatterns-${PV}-r9999
65"
66
31S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
32 68
33SRC_URI="ftp://ftp.trolltech.com/qt/source/${MY_P}.tar.bz2" 69# @FUNCTION: qt4-build_pkg_setup
34 70# @DESCRIPTION:
35case "${PV}" in 71# Sets up PATH and LD_LIBRARY_PATH.
36 4.4.2|4.4.1|4.4.0|4.4.0_rc*)
37 SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2"
38 ;;
39 *)
40 ;;
41esac
42
43qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
44 # Check USE requirements 73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
45 qt4-build_check_use
46 74
75 # Protect users by not allowing downgrades between releases
76 # Downgrading revisions within the same release should be allowed
77 if has_version '>'${CATEGORY}/${P}-r9999; then
78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:"
80 eerror " Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system"
82 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
84 fi
85 fi
86
87 if [[ ${PN} == "qt-webkit" ]]; then
88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi
97 eshopts_pop
98 fi
99
100 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then
102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
103 else
104 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
105 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
106 # platform detection. Note: needs to come before any directories to
107 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}"
111 fi
112
113 # Make sure ebuilds use the required EAPI
114 if [[ ${EAPI} != [23] ]]; then
115 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
118 die "qt4-build eclass requires EAPI=2 or EAPI=3"
119 fi
120
121 if ! version_is_at_least 4.1 $(gcc-version); then
122 ewarn "Using a GCC version lower than 4.1 is not supported!"
123 fi
124}
125
126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
127# @DESCRIPTION:
128# Arguments for build_target_directories. Takes the directories in which the
129# code should be compiled. This is a space-separated list.
130
131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
132# @DESCRIPTION:
133# Space-separated list including the directories that will be extracted from
134# Qt tarball.
135
136# @FUNCTION: qt4-build_src_unpack
137# @DESCRIPTION:
138# Unpacks the sources.
139qt4-build_src_unpack() {
140 setqtenv
141
142 local tarball="${MY_P}.tar.gz" target= targets=
143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
144 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
145 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146 do
147 targets+="${MY_P}/${target} "
148 done
149
150 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
151 tar -xzf "${DISTDIR}/${tarball}" ${targets}
152 eend $? || die "failed to unpack"
153}
154
155# @ECLASS-VARIABLE: PATCHES
156# @DEFAULT_UNSET
157# @DESCRIPTION:
158# PATCHES array variable containing all various patches to be applied.
159# This variable is expected to be defined in global scope of ebuild.
160# Make sure to specify the full path. This variable is utilised in
161# src_unpack/src_prepare phase, based on EAPI.
162#
163# @CODE
164# PATCHES=( "${FILESDIR}/mypatch.patch"
165# "${FILESDIR}/patches_folder/" )
166# @CODE
167
168# @FUNCTION: qt4-build_src_prepare
169# @DESCRIPTION:
170# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
171# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
172qt4-build_src_prepare() {
173 setqtenv
174 cd "${S}"
175
176 if version_is_at_least "4.7"; then
177 # fix libX11 dependency on non X packages
178 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
179 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180
181 qt_assistant_cleanup
182 fi
183
184 if use aqua; then
185 # provide a proper macx-g++-64
186 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
187
188 sed -e '/^CONFIG/s:app_bundle::' \
189 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
190 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
191 fi
192
193 if [[ ${PN} != qt-core ]]; then
194 skip_qmake_build
195 skip_project_generation
196 symlink_binaries_to_buildtree
197 fi
198
199 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
200 # qmake bus errors with -O2 but -O3 works
201 replace-flags -O2 -O3
202 fi
203
204 # Bug 178652
205 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
207 append-flags -fno-gcse
208 fi
209
210 if use_if_iuse c++0x; then
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 append-flags -std=c++0x
217 fi
218
219 # Unsupported old gcc versions - hardened needs this :(
220 if [[ $(gcc-major-version) -lt 4 ]] ; then
221 ewarn "Appending -fno-stack-protector to CXXFLAGS"
222 append-cxxflags -fno-stack-protector
223 # Bug 253127
224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
225 -i mkspecs/common/g++.conf || die
226 fi
227
228 # Bug 261632
229 if use ppc64; then
230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
231 append-flags -mminimal-toc
232 fi
233
234 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "/^SYSTEM_VARIABLES=/i \
236 CC='$(tc-getCC)'\n\
237 CXX='$(tc-getCXX)'\n\
238 CFLAGS='${CFLAGS}'\n\
239 CXXFLAGS='${CXXFLAGS}'\n\
240 LDFLAGS='${LDFLAGS}'\n" \
241 -i configure || die "sed SYSTEM_VARIABLES failed"
242
243 # Respect CC, CXX, LINK and *FLAGS in config.tests
244 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
245 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
246 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
247 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
248 || die "sed config.tests failed"
249
250 # Bug 172219
251 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
252
253 if [[ ${CHOST} == *-darwin* ]]; then
254 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
255 # crippled (by design) :/
256 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
257 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
258 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
259 -e "s:-arch\s\w*::g" \
260 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed"
261
262 # Fix configure's -arch settings that appear in qmake/Makefile and also
263 # fix arch handling (automagically duplicates our -arch arg and breaks
264 # pch). Additionally disable Xarch support.
265 sed \
266 -e "s:-arch i386::" \
267 -e "s:-arch ppc::" \
268 -e "s:-arch x86_64::" \
269 -e "s:-arch ppc64::" \
270 -e "s:-arch \$i::" \
271 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
272 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
273 -e "s:-Xarch_x86_64::g" \
274 -e "s:-Xarch_ppc64::g" \
275 -i configure mkspecs/common/mac-g++.conf || die "sed -arch/-Xarch failed"
276
277 # On Snow Leopard don't fall back to 10.5 deployment target.
278 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
279 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
280 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
281 -i configure mkspecs/common/mac-g++.conf || die "sed deployment target failed"
282 fi
283 fi
284
285 # this one is needed for all systems with a separate -liconv, apart from
286 # Darwin, for which the sources already cater for -liconv
287 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
288 sed \
289 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
290 -i config.tests/unix/iconv/iconv.pro \
291 || die "sed on iconv.pro failed"
292 fi
293
294 # we need some patches for Solaris
295 sed -i \
296 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
297 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
298 # use GCC over SunStudio
299 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
300 # don't flirt with non-Prefix stuff, we're quite possessive
301 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
302 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
303
304 # strip predefined CFLAGS from mkspecs (bug 312689)
305 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
306
307 base_src_prepare
308}
309
310# @FUNCTION: qt4-build_src_configure
311# @DESCRIPTION:
312# Default configure phase
313qt4-build_src_configure() {
314 setqtenv
315 myconf="$(standard_configure_options) ${myconf}"
316
317 # this one is needed for all systems with a separate -liconv, apart from
318 # Darwin, for which the sources already cater for -liconv
319 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
320 myconf+=" -liconv"
321
322 if use_if_iuse glib; then
323 # use -I, -L and -l from configure
324 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
325 # avoid the -pthread argument
326 myconf+=" ${glibflags//-pthread}"
327 unset glibflags
328 fi
329
330 if use_if_iuse qpa; then
331 ewarn
332 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
333 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
334 ewarn "disable it before reporting any bugs related to this useflag."
335 ewarn
336 myconf+=" -qpa"
337 fi
338
339 if use aqua ; then
340 # On (snow) leopard use the new (frameworked) cocoa code.
341 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
342 myconf+=" -cocoa -framework"
343
344 # We are crazy and build cocoa + qt3support :-)
345 if use qt3support; then
346 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
347 -i configure
348 fi
349
350 # We need the source's headers, not the installed ones.
351 myconf+=" -I${S}/include"
352
353 # Add hint for the framework location.
354 myconf+=" -F${QTLIBDIR}"
355 fi
356 else
357 # freetype2 include dir is non-standard, thus include it on configure
358 # use -I from configure
359 myconf+=" $(pkg-config --cflags freetype2)"
360 fi
361
362 echo ./configure ${myconf}
363 ./configure ${myconf} || die "./configure failed"
364 myconf=""
365
366 prepare_directories ${QT4_TARGET_DIRECTORIES}
367}
368
369# @FUNCTION: qt4-build_src_compile
370# @DESCRIPTION:
371# Actual compile phase
372qt4-build_src_compile() {
373 setqtenv
374
375 build_directories ${QT4_TARGET_DIRECTORIES}
376}
377
378# @FUNCTION: qt4-build_src_test
379# @DESCRIPTION:
380# Runs tests only in target directories.
381qt4-build_src_test() {
382 for dir in ${QT4_TARGET_DIRECTORIES}; do
383 emake -j1 check -C ${dir}
384 done
385}
386
387# @FUNCTION: fix_includes
388# @DESCRIPTION:
389# For MacOS X we need to add some symlinks when frameworks are
390# being used, to avoid complications with some more or less stupid packages.
391fix_includes() {
392 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
393 # Some packages tend to include <Qt/...>
394 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
395
396 # Fake normal headers when frameworks are installed... eases life later on
397 local dest f
398 for frw in "${D}${QTLIBDIR}"/*.framework; do
399 [[ -e "${frw}"/Headers ]] || continue
400 f=$(basename ${frw})
401 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
402 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
403
404 # Link normal headers as well.
405 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
406 h=$(basename ${hdr})
407 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
408 done
409 done
410 fi
411}
412
413# @FUNCTION: qt4-build_src_install
414# @DESCRIPTION:
415# Perform the actual installation including some library fixes.
416qt4-build_src_install() {
417 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
418 setqtenv
419
420 install_directories ${QT4_TARGET_DIRECTORIES}
421 install_qconfigs
422 fix_library_files
423 fix_includes
424
425 # remove .la files since we are building only shared Qt libraries
426 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm
427}
428
429# @FUNCTION: setqtenv
430# @INTERNAL
431setqtenv() {
47 # Set up installation directories 432 # Set up installation directories
48 QTBASEDIR=/usr/$(get_libdir)/qt4
49 QTPREFIXDIR=/usr 433 QTPREFIXDIR=${EPREFIX}/usr
50 QTBINDIR=/usr/bin 434 QTBINDIR=${EPREFIX}/usr/bin
51 QTLIBDIR=/usr/$(get_libdir)/qt4 435 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
52 QTPCDIR=/usr/$(get_libdir)/pkgconfig 436 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
53 QTDATADIR=/usr/share/qt4
54 QTDOCDIR=/usr/share/doc/qt-${PV} 437 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
55 QTHEADERDIR=/usr/include/qt4 438 QTHEADERDIR=${EPREFIX}/usr/include/qt4
56 QTPLUGINDIR=${QTLIBDIR}/plugins 439 QTPLUGINDIR=${QTLIBDIR}/plugins
57 QTSYSCONFDIR=/etc/qt4 440 QTIMPORTDIR=${QTLIBDIR}/imports
441 QTDATADIR=${EPREFIX}/usr/share/qt4
58 QTTRANSDIR=${QTDATADIR}/translations 442 QTTRANSDIR=${QTDATADIR}/translations
443 QTSYSCONFDIR=${EPREFIX}/etc/qt4
59 QTEXAMPLESDIR=${QTDATADIR}/examples 444 QTEXAMPLESDIR=${QTDATADIR}/examples
60 QTDEMOSDIR=${QTDATADIR}/demos 445 QTDEMOSDIR=${QTDATADIR}/demos
446 QMAKE_LIBDIR_QT=${QTLIBDIR}
447 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
61 448
62 PLATFORM=$(qt_mkspecs_dir) 449 PLATFORM=$(qt_mkspecs_dir)
63 450
64 PATH="${S}/bin:${PATH}" 451 unset QMAKESPEC
65 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}"
66} 452}
67 453
68qt4_unpack() { 454# @FUNCTION: standard_configure_options
69 local target targets 455# @INTERNAL
70 for target in configure LICENSE.{GPL2,GPL3} projects.pro \ 456# @DESCRIPTION:
71 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 457# Sets up some standard configure options, like libdir (if necessary), whether
72 ${QT4_EXTRACT_DIRECTORIES}; do 458# debug info is wanted or not.
73 targets="${targets} ${MY_P}/${target}" 459standard_configure_options() {
460 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
461 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
462 -importdir ${QTIMPORTDIR} -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR}
463 -sysconfdir ${QTSYSCONFDIR} -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
464 -opensource -confirm-license -shared -fast -largefile -stl -verbose
465 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
466
467 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
468
469 # debug/release
470 if use debug; then
471 myconf+=" -debug"
472 else
473 myconf+=" -release"
474 fi
475 myconf+=" -no-separate-debug-info"
476
477 # exceptions USE flag
478 local exceptions="-exceptions"
479 in_iuse exceptions && exceptions="$(qt_use exceptions)"
480 myconf+=" ${exceptions}"
481
482 # disable RPATH on Qt >= 4.8 (bug 380415)
483 version_is_at_least 4.8 && myconf+=" -no-rpath"
484
485 # precompiled headers don't work on hardened, where the flag is masked
486 myconf+=" $(qt_use pch)"
487
488 # -reduce-relocations
489 # This flag seems to introduce major breakage to applications,
490 # mostly to be seen as a core dump with the message "QPixmap: Must
491 # construct a QApplication before a QPaintDevice" on Solaris.
492 # -- Daniel Vergien
493 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
494
495 use aqua && myconf+=" -no-framework"
496
497 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
498 # $(tc-arch). Therefore we convert it to supported values.
499 case "$(tc-arch)" in
500 amd64|x64-*) myconf+=" -arch x86_64" ;;
501 ppc-macos) myconf+=" -arch ppc" ;;
502 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
503 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
504 x86-macos) myconf+=" -arch x86" ;;
505 x86|x86-*) myconf+=" -arch i386" ;;
506 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
507 hppa|sh) myconf+=" -arch generic" ;;
508 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
509 esac
510
511 echo "${myconf}"
512}
513
514# @FUNCTION: prepare_directories
515# @USAGE: < directories >
516# @INTERNAL
517# @DESCRIPTION:
518# Generates Makefiles for the given list of directories.
519prepare_directories() {
520 for x in "$@"; do
521 pushd "${S}"/${x} >/dev/null || die
522 einfo "Running qmake in: ${x}"
523 # avoid running over the maximum argument number, bug #299810
524 {
525 echo "${S}"/mkspecs/common/*.conf
526 find "${S}" -name '*.pr[io]'
527 } | xargs sed -i \
528 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
529 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
530 || die
531 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
532 popd >/dev/null || die
74 done 533 done
75
76 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets}
77 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets}
78
79 case "${PV}" in
80 4.4.2|4.4.1|4.4.0|4.4.0_rc*)
81 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
82 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
83 ;;
84 esac
85} 534}
86 535
87qt4-build_src_unpack() {
88 qt4_unpack
89 if [[ ${PN} != qt-core ]]; then
90 cd "${S}"
91 skip_qmake_build_patch
92 skip_project_generation_patch
93 symlink_binaries_to_buildtree
94 fi
95 536
96 # Bug 253127 537# @FUNCTION: build_directories
97 if [[ $(gcc-major-version) -lt "4" ]] ; then 538# @USAGE: < directories >
98 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 539# @INTERNAL
99 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 540# @DESCRIPTION:
100 fi 541# Compiles the code in the given list of directories.
101
102 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
103 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
104 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
105 -e "s:X11R6/::" \
106 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
107
108 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
109 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
110 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
111 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
112}
113
114qt4-build_src_compile() {
115 # Don't let the user go too overboard with flags. If you really want to, uncomment
116 # out the line below and give 'er a whirl.
117 strip-flags
118 replace-flags -O3 -O2
119
120 if [[ $(gcc-major-version) -lt "4" ]] ; then
121 ewarn "Appending -fno-stack-protector to CXXFLAGS"
122 append-cxxflags -fno-stack-protector
123 fi
124
125 # Bug 178652
126 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then
127 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
128 append-flags -fno-gcse
129 fi
130
131 myconf="$(standard_configure_options) ${myconf}"
132
133 echo ./configure ${myconf}
134 ./configure ${myconf} || die "./configure failed"
135
136 build_target_directories
137}
138
139qt4-build_src_install() {
140 install_directories "${QT4_TARGET_DIRECTORIES}"
141 install_qconfigs
142 fix_library_files
143}
144
145standard_configure_options() {
146 local myconf=""
147
148 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)"
149
150 # Disable visibility explicitly if gcc version isn't 4
151 if [[ "$(gcc-major-version)" -lt "4" ]]; then
152 myconf="${myconf} -no-reduce-exports"
153 fi
154
155 # precompiled headers doesn't work on hardened, where the flag is masked.
156 if use pch; then
157 myconf="${myconf} -pch"
158 else
159 myconf="${myconf} -no-pch"
160 fi
161
162 if use debug; then
163 myconf="${myconf} -debug -no-separate-debug-info"
164 else
165 myconf="${myconf} -release -no-separate-debug-info"
166 fi
167
168 # ARCH is set on Gentoo. QT now falls back to generic on an unsupported
169 # ${ARCH}. Therefore we convert it to supported values.
170 case "${ARCH}" in
171 amd64) myconf="${myconf} -arch x86_64" ;;
172 ppc|ppc64) myconf="${myconf} -arch powerpc" ;;
173 x86|x86-*) myconf="${myconf} -arch i386" ;;
174 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch ${ARCH}" ;;
175 hppa|sh) myconf="${myconf} -arch generic" ;;
176 *) die "${ARCH} is unsupported by this eclass. Please file a bug." ;;
177 esac
178
179 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath
180 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
181 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
182 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
183 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
184 -demosdir ${QTDEMOSDIR} -silent -fast -reduce-relocations
185 -nomake examples -nomake demos"
186
187 echo "${myconf}"
188}
189
190build_target_directories() {
191 build_directories "${QT4_TARGET_DIRECTORIES}"
192}
193
194build_directories() { 542build_directories() {
195 local dirs="$@"
196 for x in ${dirs}; do 543 for x in "$@"; do
197 cd "${S}"/${x} 544 pushd "${S}"/${x} >/dev/null || die
198 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 545 emake CC="$(tc-getCC)" \
199 emake || die "emake failed" 546 CXX="$(tc-getCXX)" \
547 LINK="$(tc-getCXX)" || die "emake failed"
548 popd >/dev/null || die
200 done 549 done
201} 550}
202 551
552# @FUNCTION: install_directories
553# @USAGE: < directories >
554# @INTERNAL
555# @DESCRIPTION:
556# Runs emake install in the given directories, which are separated by spaces.
203install_directories() { 557install_directories() {
204 local dirs="$@"
205 for x in ${dirs}; do 558 for x in "$@"; do
206 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 559 pushd "${S}"/${x} >/dev/null || die
207 emake INSTALL_ROOT="${D}" install || die "emake install failed" 560 emake INSTALL_ROOT="${D}" install || die "emake install failed"
208 popd >/dev/null || die "Can't popd from ${S}/${x}" 561 popd >/dev/null || die
209 done 562 done
210} 563}
211 564
212# @ECLASS-VARIABLE: QCONFIG_ADD 565# @ECLASS-VARIABLE: QCONFIG_ADD
213# @DESCRIPTION: 566# @DESCRIPTION:
214# List options that need to be added to QT_CONFIG in qconfig.pri 567# List options that need to be added to QT_CONFIG in qconfig.pri
215QCONFIG_ADD="${QCONFIG_ADD:-}" 568: ${QCONFIG_ADD:=}
216 569
217# @ECLASS-VARIABLE: QCONFIG_REMOVE 570# @ECLASS-VARIABLE: QCONFIG_REMOVE
218# @DESCRIPTION: 571# @DESCRIPTION:
219# List options that need to be removed from QT_CONFIG in qconfig.pri 572# List options that need to be removed from QT_CONFIG in qconfig.pri
220QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 573: ${QCONFIG_REMOVE:=}
221 574
222# @ECLASS-VARIABLE: QCONFIG_DEFINE 575# @ECLASS-VARIABLE: QCONFIG_DEFINE
223# @DESCRIPTION: 576# @DESCRIPTION:
224# List variables that should be defined at the top of QtCore/qconfig.h 577# List variables that should be defined at the top of QtCore/qconfig.h
225QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 578: ${QCONFIG_DEFINE:=}
226 579
580# @FUNCTION: install_qconfigs
581# @INTERNAL
582# @DESCRIPTION:
583# Install gentoo-specific mkspecs configurations.
227install_qconfigs() { 584install_qconfigs() {
228 local x 585 local x
229 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 586 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
230 for x in QCONFIG_ADD QCONFIG_REMOVE; do 587 for x in QCONFIG_ADD QCONFIG_REMOVE; do
231 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 588 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
232 done 589 done
233 insinto ${QTDATADIR}/mkspecs/gentoo 590 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
234 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 591 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
235 fi 592 fi
236 593
237 if [[ -n ${QCONFIG_DEFINE} ]]; then 594 if [[ -n ${QCONFIG_DEFINE} ]]; then
238 for x in ${QCONFIG_DEFINE}; do 595 for x in ${QCONFIG_DEFINE}; do
239 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 596 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
240 done 597 done
241 insinto ${QTHEADERDIR}/Gentoo 598 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
242 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 599 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
243 fi 600 fi
244} 601}
245 602
246# Stubs for functions used by the Qt 4.4.0_technical_preview_1. 603# @FUNCTION: generate_qconfigs
247qconfig_add_option() { : ; } 604# @INTERNAL
248qconfig_remove_option() { : ; } 605# @DESCRIPTION:
249 606# Generates gentoo-specific qconfig.{h,pri}.
250generate_qconfigs() { 607generate_qconfigs() {
251 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 608 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
252 local x qconfig_add qconfig_remove qconfig_new 609 local x qconfig_add qconfig_remove qconfig_new
253 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 610 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
254 [[ -f ${x} ]] || continue 611 [[ -f ${x} ]] || continue
255 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 612 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
256 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 613 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
257 done 614 done
258 615
259 # these error checks do not use die because dying in pkg_post{inst,rm} 616 # these error checks do not use die because dying in pkg_post{inst,rm}
260 # just makes things worse. 617 # just makes things worse.
261 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 618 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
268 625
269 # generate list of QT_CONFIG entries from the existing list 626 # generate list of QT_CONFIG entries from the existing list
270 # including qconfig_add and excluding qconfig_remove 627 # including qconfig_add and excluding qconfig_remove
271 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 628 for x in $(sed -n 's/^QT_CONFIG +=//p' \
272 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 629 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
273 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 630 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
274 done 631 done
275 632
276 # replace the existing QT_CONFIG list with qconfig_new 633 # replace the existing QT_CONFIG list with qconfig_new
277 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 634 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
278 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 635 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
301 "${ROOT}${QTHEADERDIR}" 2>/dev/null 658 "${ROOT}${QTHEADERDIR}" 2>/dev/null
302 fi 659 fi
303 fi 660 fi
304} 661}
305 662
663# @FUNCTION: qt4-build_pkg_postrm
664# @DESCRIPTION:
665# Regenerate configuration when the package is completely removed.
306qt4-build_pkg_postrm() { 666qt4-build_pkg_postrm() {
307 generate_qconfigs 667 generate_qconfigs
308} 668}
309 669
670# @FUNCTION: qt4-build_pkg_postinst
671# @DESCRIPTION:
672# Regenerate configuration, plus throw a message about possible
673# breakages and proposed solutions.
310qt4-build_pkg_postinst() { 674qt4-build_pkg_postinst() {
311 generate_qconfigs 675 generate_qconfigs
312 echo
313 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
314 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
315 ewarn "should recompile the packages providing these plugins. Also, make sure you"
316 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
317 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
318 ewarn
319 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
320 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
321 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
322 ewarn "configuration."
323 ewarn
324 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
325 echo
326} 676}
327 677
678# @FUNCTION: skip_qmake_build
679# @INTERNAL
680# @DESCRIPTION:
681# Patches configure to skip qmake compilation, as it's already installed by qt-core.
328skip_qmake_build_patch() { 682skip_qmake_build() {
329 # Don't need to build qmake, as it's already installed from qt-core
330 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 683 sed -i -e "s:if true:if false:g" "${S}"/configure || die
331} 684}
332 685
333skip_project_generation_patch() { 686# @FUNCTION: skip_project_generation
687# @INTERNAL
688# @DESCRIPTION:
334 # Exit the script early by throwing in an exit before all of the .pro files are scanned 689# Exit the script early by throwing in an exit before all of the .pro files are scanned.
690skip_project_generation() {
335 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 691 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
336 -i "${S}"/configure || die "Sed failed"
337} 692}
338 693
694# @FUNCTION: symlink_binaries_to_buildtree
695# @INTERNAL
696# @DESCRIPTION:
697# Symlinks generated binaries to buildtree, so they can be used during compilation time.
339symlink_binaries_to_buildtree() { 698symlink_binaries_to_buildtree() {
340 for bin in qmake moc uic rcc; do 699 for bin in qmake moc uic rcc; do
341 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 700 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
342 done 701 done
343} 702}
344 703
704# @FUNCTION: fix_library_files
705# @INTERNAL
706# @DESCRIPTION:
707# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
708# moves the *.pc files into the pkgconfig directory.
345fix_library_files() { 709fix_library_files() {
710 local libfile
346 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 711 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
347 if [[ -e ${libfile} ]]; then 712 if [[ -e ${libfile} ]]; then
348 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 713 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
349 fi 714 fi
350 done 715 done
351 716
352 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 717 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
353 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 718 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
354 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
355 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 720 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
356 721
357 # Move .pc files into the pkgconfig directory 722 # Move .pc files into the pkgconfig directory
358
359 dodir ${QTPCDIR} 723 dodir ${QTPCDIR#${EPREFIX}}
360 mv ${libfile} "${D}"/${QTPCDIR}/ \ 724 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
361 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
362 fi 725 fi
363 done 726 done
364 727
365 # Don't install an empty directory 728 # Don't install an empty directory
366 rmdir "${D}"/${QTLIBDIR}/pkgconfig 729 rmdir "${D}"/${QTLIBDIR}/pkgconfig
367} 730}
368 731
732# @FUNCTION: qt_use
733# @USAGE: < flag > [ feature ] [ enableval ]
734# @DESCRIPTION:
735# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
736# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
737# will be used for that. If [enableval] is not specified, it omits the
738# "-${enableval}" part.
369qt_use() { 739qt_use() {
370 local flag="${1}" 740 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
371 local feature="${1}"
372 local enableval=
373
374 [[ -n ${2} ]] && feature=${2}
375 [[ -n ${3} ]] && enableval="-${3}"
376
377 if use ${flag}; then
378 echo "${enableval}-${feature}"
379 else
380 echo "-no-${feature}"
381 fi
382} 741}
383 742
384# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK 743# @FUNCTION: qt_mkspecs_dir
744# @RETURN: the specs-directory w/o path
385# @DESCRIPTION: 745# @DESCRIPTION:
386# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use 746# Allows us to define which mkspecs dir we want to use.
387# (eutils.eclass), line per line.
388#
389# Example:
390# @CODE
391# pkg_setup() {
392# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
393# ~x11-libs/qt-gui-${PV} qt3support"
394# qt4-build_check_use
395# }
396# @CODE
397
398# Run built_with_use on each flag and print appropriate error messages if any
399# flags are missing
400_qt_built_with_use() {
401 local missing opt pkg flag flags
402
403 if [[ ${1} = "--missing" ]]; then
404 missing="${1} ${2}" && shift 2
405 fi
406 if [[ ${1:0:1} = "-" ]]; then
407 opt=${1} && shift
408 fi
409
410 pkg=${1} && shift
411
412 for flag in "${@}"; do
413 flags="${flags} ${flag}"
414 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
415 flags="${flags}*"
416 else
417 [[ ${opt} = "-o" ]] && return 0
418 fi
419 done
420 if [[ "${flags# }" = "${@}" ]]; then
421 return 0
422 fi
423 if [[ ${opt} = "-o" ]]; then
424 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
425 else
426 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
427 fi
428 return 1
429}
430
431# @FUNCTION: qt4-build_check_use
432# @DESCRIPTION:
433# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
434# USE flags listed.
435#
436# If any of the required USE flags are missing, an eerror will be printed for
437# each package with missing USE flags.
438qt4-build_check_use() {
439 local line missing
440 while read line; do
441 [[ -z ${line} ]] && continue
442 if ! _qt_built_with_use ${line}; then
443 missing=true
444 fi
445 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
446 if [[ -n ${missing} ]]; then
447 echo
448 eerror "Flags marked with an * are missing."
449 die "Missing USE flags found"
450 fi
451}
452
453qt_mkspecs_dir() { 747qt_mkspecs_dir() {
454 # Allows us to define which mkspecs dir we want to use.
455 local spec 748 local spec=
456
457 case ${CHOST} in 749 case ${CHOST} in
458 *-freebsd*|*-dragonfly*) 750 *-freebsd*|*-dragonfly*)
459 spec="freebsd" ;; 751 spec=freebsd ;;
460 *-openbsd*) 752 *-openbsd*)
461 spec="openbsd" ;; 753 spec=openbsd ;;
462 *-netbsd*) 754 *-netbsd*)
463 spec="netbsd" ;; 755 spec=netbsd ;;
464 *-darwin*) 756 *-darwin*)
757 if use aqua; then
758 # mac with carbon/cocoa
759 spec=macx
760 else
761 # darwin/mac with x11
465 spec="darwin" ;; 762 spec=darwin
763 fi
764 ;;
765 *-solaris*)
766 spec=solaris ;;
466 *-linux-*|*-linux) 767 *-linux-*|*-linux)
467 spec="linux" ;; 768 spec=linux ;;
468 *) 769 *)
469 die "Unknown CHOST, no platform choosen." 770 die "Unknown CHOST, no platform chosen"
470 esac 771 esac
471 772
472 CXX=$(tc-getCXX) 773 CXX=$(tc-getCXX)
473 if [[ ${CXX/g++/} != ${CXX} ]]; then 774 if [[ ${CXX} == *g++* ]]; then
474 spec="${spec}-g++" 775 spec+=-g++
475 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 776 elif [[ ${CXX} == *icpc* ]]; then
476 spec="${spec}-icc" 777 spec+=-icc
477 else 778 else
478 die "Unknown compiler ${CXX}." 779 die "Unknown compiler '${CXX}'"
780 fi
781 if [[ -n ${LIBDIR/lib} ]]; then
782 spec+=-${LIBDIR/lib}
783 fi
784
785 # Add -64 for 64bit profiles
786 if use x64-freebsd ||
787 use amd64-linux ||
788 use x64-macos ||
789 use x64-solaris ||
790 use sparc64-solaris
791 then
792 spec+=-64
479 fi 793 fi
480 794
481 echo "${spec}" 795 echo "${spec}"
482} 796}
483 797
798# @FUNCTION: qt_assistant_cleanup
799# @INTERNAL
800# @DESCRIPTION:
801# Tries to clean up tools.pro for qt-assistant ebuilds.
802# Meant to be called in src_prepare().
803# Since Qt 4.7.4 this function is a no-op.
804qt_assistant_cleanup() {
805 # apply patching to qt-assistant ebuilds only
806 [[ ${PN} != "qt-assistant" ]] && return
807
808 # no longer needed for 4.7.4 and later
809 version_is_at_least "4.7.4" && return
810
811 # different versions (and branches...) may need different handling,
812 # add a case if you need special handling
813 case "${MY_PV_EXTRA}" in
814 *kde-qt*)
815 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
816 -e "/mac/,/^embedded.*makeqpf$/d" \
817 -i tools/tools.pro || die "patching tools.pro failed"
818 ;;
819 *)
820 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
821 -e "/mac/,/^embedded.*makeqpf$/d" \
822 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
823 -i tools/tools.pro || die "patching tools.pro failed"
824 ;;
825 esac
826}
827
828# @FUNCTION: qt_nolibx11
829# @INTERNAL
830# @DESCRIPTION:
831# Ignore X11 tests for packages that don't need X libraries installed.
832qt_nolibx11() {
833 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
834 die "x11 check sed failed"
835}
836
484EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst 837EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.18  
changed lines
  Added in v.1.113

  ViewVC Help
Powered by ViewVC 1.1.20